/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.modules.guosen.helpRecord.wrapper;

import org.springblade.core.mp.support.BaseEntityWrapper;
import org.springblade.core.tool.utils.BeanUtil;
import org.springblade.modules.guosen.activity.entity.Activity;
import org.springblade.modules.guosen.activity.service.IActivityService;
import org.springblade.modules.guosen.helpRecord.dto.HelpRecordDTO;
import org.springblade.modules.guosen.helpRecord.entity.HelpRecord;
import org.springblade.modules.guosen.helpRecord.vo.HelpRecordVO;
import org.springblade.modules.guosen.loginUser.entity.LoginUser;
import org.springblade.modules.guosen.loginUser.service.ILoginUserService;
import org.springblade.modules.guosen.loginUser.vo.LoginWebVO;
import org.springblade.modules.guosen.present.entity.Present;
import org.springblade.modules.guosen.present.service.IPresentService;
import org.springblade.modules.guosen.production.entity.Production;
import org.springblade.modules.guosen.production.service.IProductionService;

import java.util.Objects;

/**
 * 包装类,返回视图层所需的字段
 *
 * @author BladeX
 * @since 2021-06-17
 */
public class HelpRecordWrapper extends BaseEntityWrapper<HelpRecord, HelpRecordVO>  {
	private ILoginUserService loginUserService;
	private IActivityService activityService;
	private IProductionService productionService;
	private IPresentService presentService;

	public HelpRecordWrapper(ILoginUserService loginUserService, IActivityService activityService
		,IProductionService productionService,IPresentService presentService) {
		this.loginUserService = loginUserService;
		this.activityService = activityService;
		this.productionService = productionService;
		this.presentService = presentService;
	}

	public HelpRecordWrapper(ILoginUserService loginUserService) {
		this.loginUserService = loginUserService;
	}

	public static HelpRecordWrapper build(ILoginUserService loginUserService, IActivityService activityService
		, IProductionService productionService, IPresentService presentService) {
		return new HelpRecordWrapper(loginUserService,activityService,productionService,presentService);
 	}

	public static HelpRecordWrapper build(ILoginUserService loginUserService) {
		return new HelpRecordWrapper(loginUserService);
	}

	@Override
	public HelpRecordVO entityVO(HelpRecord helpRecord) {
		HelpRecordVO helpRecordVO = Objects.requireNonNull(BeanUtil.copy(helpRecord, HelpRecordVO.class));

		if (helpRecordVO != null && activityService!=null) {
			Activity activity = activityService.getById(helpRecordVO.getActivityId());
			LoginUser sender = loginUserService.getById(helpRecordVO.getSenderId());
			LoginUser receiver = loginUserService.getById(helpRecordVO.getReceiverId());
			Production production = productionService.getById(helpRecordVO.getProductId());
			Present present = presentService.getById(helpRecordVO.getPresentId());
			if (production != null) {
				helpRecordVO.setProductionName(production.getTitle());
			}
			if (present != null) {
				helpRecordVO.setPresent(present);
			}
			LoginWebVO senderWeb = new LoginWebVO();
			LoginWebVO receiverWeb = new LoginWebVO();
			if (sender != null) {
				BeanUtil.copyProperties(sender, senderWeb);
			}
			if (receiver != null) {
				BeanUtil.copyProperties(receiver, receiverWeb);
			}
			helpRecordVO.setSender(senderWeb);
			helpRecordVO.setReceiver(receiverWeb);
			helpRecordVO.setActivityName(activity.getName());
		}

		if (helpRecordVO != null && activityService == null && loginUserService!=null) {
			LoginUser sender = loginUserService.getById(helpRecordVO.getSenderId());
			if (sender != null) {
				helpRecordVO.setAvatar(sender.getAvatar());
				helpRecordVO.setNickName(sender.getNickName());
			}
		}

		return helpRecordVO;
	}

}
